Imports System.Data
Imports System.Data.SqlClient
Imports Microsoft.Web.AJAXExtensions
Imports System.Collections.Generic
Imports System.Drawing
Imports Infragistics.WebUI.UltraWebGrid.ExcelExport
Imports Infragistics.WebUI.WebSchedule
Imports Infragistics.WebUI.UltraWebToolbar
Imports Infragistics.WebUI.UltraWebNavigator
Imports Infragistics.WebUI.UltraWebGrid
Imports Infragistics.WebUI.UltraWebGrid.DocumentExport
Imports Infragistics.Documents.Report
Imports ReportText = Infragistics.Documents.Report.Text
Imports ReportFooter = Infragistics.Documents.Report.Section
Imports ReportImage = Infragistics.Documents.Report.IImage
Imports ReportImageLoader = Infragistics.Documents.Report.IImageLoader

Partial Class Consultants_viewassignments
    Inherits System.Web.UI.Page
    Public Shared intTypeId As Integer
    Public Shared intType As Integer
    Public Shared HttpRefer As String
    Public Shared strConName As String
    Public Shared intConId As String
    Public Shared bolStatus As String
    Dim fromURI As Integer
    Dim ConId As Integer
    Dim arryFilters As String()

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not Page.IsPostBack Then

            Dim mu As MembershipUser = Membership.GetUser(User.Identity.Name)
            Session("UserId") = mu.ProviderUserKey.ToString()
            CheckRoles()
            fromURI = Request.QueryString("fromURL")
            ConId = Request.QueryString("ConId")
            HttpRefer = Request.QueryString("returnURL")
            bolStatus = Request.QueryString("status")
            Select Case bolStatus
                Case "Open"
                    bolStatus = "False"
                Case "Closed"
                    bolStatus = "True"
            End Select
            Select Case fromURI
                Case 1
                    If (HttpRefer Is Nothing) Then
                        'Do Nothing
                    ElseIf HttpRefer.EndsWith("viewaddconsultant.aspx") Then
                        btnBackReferer.Visible = True
                        btnBackReferer.Text = "Back To Resources"
                    End If
                Case Else
                    intTypeId = Request.QueryString("intTypeId")
                    intType = Request.QueryString("intType")
                    strConName = Request.QueryString("conName")

                    If Not (intTypeId = 0) And Not (intType = 0) Then
                        bindHttpReferParams(intType, intTypeId, bolStatus)
                    End If
                    If Not (HttpRefer = "") And (strConName = "") Then
                        btnBackReferer.Visible = True
                        Select Case intType
                            Case 1
                                btnBackReferer.Text = "Back To Clients"
                            Case 2
                                btnBackReferer.Text = "Back To Projects"
                        End Select

                    ElseIf Not (strConName = "") And Not (HttpRefer = "") Then
                        ckProjectFilter.Checked = False
                        ddlFilterType.SelectedIndex = 3
                        txtConsultant.Visible = True
                        txtConsultant.Text = strConName
                        btnConsultSearch.Visible = True
                        btnBackReferer.Visible = True
                        btnBackReferer.Text = "Back To Add Consultant"
                        webGridAssignments.DataBind()
                    End If
            End Select
        End If

    End Sub

    Private Sub getProjects()
        Dim DBAccess As New PayrollDBAccess.payrollDataAccess
        Dim reader As SqlDataReader
        Dim proj_filter As Boolean = ckProjectFilter.Checked
        reader = DBAccess.RunSPwithParamsRS("getProjectNames", New SqlParameter("@filterOpenPojects", proj_filter))
        ddlID.DataSource = reader
        ddlID.DataTextField = "proj_name"
        ddlID.DataValueField = "proj_id"
        ddlID.DataBind()
        reader.Close()
        ddlID.Items.Insert(0, "<-Select Project->")
        ddlID.SelectedItem.Value = 0
    End Sub

    Private Sub bindHttpReferParams(ByVal type As Integer, ByVal typeId As Integer, ByVal projStatus As Boolean)
        ddlFilterType.SelectedValue = type
        ddlID.Enabled = True
        ckProjectFilter.Checked = projStatus
        Select Case type
            Case 1
                getClients()
            Case 2
                getProjects()
        End Select
        ddlID.SelectedValue = typeId
        Select Case User.IsInRole("Project Managers")
            Case False
                webGridAssignments.DataBind()
            Case True
                webGridAssignments.DataSource = Nothing
                webGridAssignments.DataBind()
        End Select

    End Sub

    Private Sub getClients()
        Dim DBAccess As New PayrollDBAccess.payrollDataAccess
        Dim reader As SqlDataReader
        reader = DBAccess.runSPReturnRS("getClientNames")
        ddlID.DataSource = reader
        ddlID.DataTextField = "client_name"
        ddlID.DataValueField = "clientID"
        ddlID.DataBind()
        reader.Close()
        ddlID.Items.Insert(0, "<-Select->")
        ddlID.SelectedItem.Value = 0
    End Sub

    Private Sub GetAssignments()

        Select Case ddlFilterType.SelectedIndex
            Case 3
                ddlID.Items.Clear()
                ddlID.Enabled = False
                ddlID.Visible = False
                btnConsultSearch.Visible = True
                txtConsultant.Visible = True
                lblConName.Visible = True
            Case 2
                ddlID.Items.Clear()
                ddlID.Enabled = True
                ddlID.Visible = True
                btnConsultSearch.Visible = False
                txtConsultant.Visible = False
                lblConName.Visible = False
                getProjects()

            Case 1
                ddlID.Items.Clear()
                ddlID.Enabled = True
                ddlID.Visible = True
                btnConsultSearch.Visible = False
                txtConsultant.Visible = False
                lblConName.Visible = False
                getClients()
            Case 0
                ddlID.Items.Clear()
                ddlID.Enabled = False
                ddlID.Visible = False
                btnConsultSearch.Visible = False
                txtConsultant.Visible = False
                lblConName.Visible = False

        End Select
    End Sub

    Private Sub CheckRoles()

        If User.IsInRole("Sales") Or User.IsInRole("Recruiters") Then

            webGridAssignments.Columns(6).AllowUpdate = AllowUpdate.No
            webGridAssignments.Columns(7).AllowUpdate = AllowUpdate.No
            webGridAssignments.Columns(8).AllowUpdate = AllowUpdate.No
            webGridAssignments.Columns(9).AllowUpdate = AllowUpdate.No
            webGridAssignments.Columns(13).AllowUpdate = AllowUpdate.No
            webGridAssignments.Columns(15).AllowUpdate = AllowUpdate.No
            webGridAssignments.Columns(21).AllowUpdate = AllowUpdate.No
            webGridAssignments.Columns(23).AllowUpdate = AllowUpdate.No
            webGridAssignments.Columns(24).AllowUpdate = AllowUpdate.No
            webGridAssignments.Columns(25).AllowUpdate = AllowUpdate.No
            webGridAssignments.Columns(26).AllowUpdate = AllowUpdate.No

            webGridAssignments.Columns(6).Header.Image.Url = Nothing
            webGridAssignments.Columns(7).Header.Image.Url = Nothing
            webGridAssignments.Columns(8).Header.Image.Url = Nothing
            webGridAssignments.Columns(9).Header.Image.Url = Nothing
            webGridAssignments.Columns(13).Header.Image.Url = Nothing
            webGridAssignments.Columns(15).Header.Image.Url = Nothing
            webGridAssignments.Columns(21).Header.Image.Url = Nothing
            webGridAssignments.Columns(23).Header.Image.Url = Nothing
            webGridAssignments.Columns(24).Header.Image.Url = Nothing
            webGridAssignments.Columns(25).Header.Image.Url = Nothing
            webGridAssignments.Columns(26).Header.Image.Url = Nothing

            webGridAssignments.Columns(29).Hidden = True
            webGridAssignments.Columns(30).Hidden = True
            webGridAssignments.Columns(31).Hidden = True
            UltraWebToolbar1.Visible = False
            webGridAssignments.Bands(0).AllowDelete = AllowDelete.No
        ElseIf User.IsInRole("Project Managers") Then
            webGridAssignments.Columns(29).Hidden = True
            webGridAssignments.Columns(30).Hidden = True
            webGridAssignments.Columns(31).Hidden = True
            webGridAssignments.Bands(0).AllowDelete = AllowDelete.No
        ElseIf User.IsInRole("Payroll Admins") Or User.IsInRole("Resource Managers") Then

        Else

        End If

    End Sub


    Protected Sub ckProjectFilter_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ckProjectFilter.CheckedChanged
        Select Case ckProjectFilter.Checked
            Case False
                If ddlFilterType.SelectedValue = 2 Then
                    ddlID.Items.Clear()
                    getProjects()
                End If
                ckProjectFilter.Text = "Viewing All Projects"
            Case True
                If ddlFilterType.SelectedValue = 2 Then
                    ddlID.Items.Clear()
                    getProjects()
                End If
                ckProjectFilter.Text = "Viewing Open Projects/Active Resources"
        End Select
    End Sub

    Protected Sub webGridAssignments_DeleteRowBatch(ByVal sender As Object, ByVal e As Infragistics.WebUI.UltraWebGrid.RowEventArgs) Handles webGridAssignments.DeleteRowBatch
        Dim strRow As UltraGridCell = e.Row.Cells.FromKey("end_date")
        If strRow.Text = "" Then
            e.Cancel = True
        End If
    End Sub

    Private Sub BindGrid()
        Dim dt As DataTable = Nothing
        dt = CType(Session("gridColNames"), DataTable)
        grdViewCols.DataSource = dt
        grdViewCols.DataBind()
    End Sub

    Protected Sub webGridAssignments_InitializeBand(ByVal sender As Object, ByVal e As Infragistics.WebUI.UltraWebGrid.BandEventArgs) Handles webGridAssignments.InitializeBand
        Dim dt As DataTable = New DataTable()
        Dim boolChecked As Boolean

        dt.TableName = "SqlDSAssignments_DefaultView"
        dt.Columns.Add("oColumn")
        dt.Columns.Add("oKey")
        If e.Band.DataKeyField = "proj_assign_id" Then
            For Each col As UltraGridColumn In e.Band.Columns
                Dim colKey As String = col.Key
                Dim colName As String = col.Header.Caption
                If Not (colKey = "proj_assign_id") Then
                    If Not (col.Hidden = True) Then
                        boolChecked = True
                        dt.Rows.Add(colName, colKey)
                    End If
                End If
            Next
        End If
        Session("gridColNames") = dt
        BindGrid()
    End Sub

    Protected Sub webGridAssignments_InitializeLayout(ByVal sender As Object, ByVal e As Infragistics.WebUI.UltraWebGrid.LayoutEventArgs) Handles webGridAssignments.InitializeLayout
        Dim dt As DataTable = New DataTable()
        Dim boolChecked As Boolean

        dt.TableName = "SqlDSAssignments_DefaultView"
        dt.Columns.Add("oColumn")
        dt.Columns.Add("oKey")
        If webGridAssignments.Bands(0).DataKeyField = "proj_assign_id" Then
            For Each col As UltraGridColumn In webGridAssignments.Bands(0).Columns
                Dim colKey As String = col.Key
                Dim colName As String = col.Header.Caption
                If Not (colKey = "proj_assign_id") Then
                    If Not (col.Hidden = True) Then
                        boolChecked = True
                        dt.Rows.Add(colName, colKey)
                    End If
                End If
            Next
        End If
        Session("gridColNames") = dt
        BindGrid()
    End Sub

    Protected Sub webGridAssignments_InitializeRow(ByVal sender As Object, ByVal e As Infragistics.WebUI.UltraWebGrid.RowEventArgs) Handles webGridAssignments.InitializeRow

        Dim mu As MembershipUser = Membership.GetUser(User.Identity.Name)
        Dim currUserId As String = mu.ProviderUserKey.ToString()
        Dim row As UltraGridRow = Me.webGridAssignments.Rows.FromKey("proj_assign_id")

        For Each Band As UltraGridBand In webGridAssignments.Bands
            If Band.DataKeyField = "proj_assign_id" Then
                'Dim uIdIndex As Integer = e.Row.Cells.IndexOf("UserId")
                'Dim UserId As String = e.Row.Cells.Item(uIdIndex).ToString()
                Dim key As Integer = e.Row.DataKey
                Dim UserId As String
                If Not (e.Row.Cells.FromKey("UserId") Is Nothing) Then
                    UserId = e.Row.Cells.FromKey("UserId").Value.ToString()
                End If

                Dim rowCode As UltraGridRow = webGridAssignments.Rows.FromKey("sales_name")
                Dim colCode As UltraGridColumn = webGridAssignments.Columns.FromKey("sales_name")
                Dim strCode As UltraGridCell = e.Row.Cells.FromKey("sales_name")

                If Not (strCode Is Nothing) Then
                    If strCode.Text = "Unassigned" Then
                        e.Row.Cells.FromKey("gen_flag").AllowEditing = AllowEditing.No
                    End If
                End If

                If User.IsInRole("Sales") Or User.IsInRole("Recruiters") Then

                    For Each cell As UltraGridCell In e.Row.Cells
                        cell.AllowEditing = AllowEditing.No
                    Next

                ElseIf User.IsInRole("Project Managers") Then
                    If UserId <> currUserId Then
                        For Each cell As UltraGridCell In e.Row.Cells
                            cell.AllowEditing = AllowEditing.No
                            e.Row.RowSelectorStyle.BackgroundImage = Nothing
                        Next
                    Else
                        e.Row.RowSelectorStyle.BackgroundImage = "./editable.png"
                    End If
                ElseIf User.IsInRole("Payroll Admins") Or User.IsInRole("Resource Managers") Then
                    e.Row.RowSelectorStyle.BackgroundImage = "./editable.png"
                End If
            End If
        Next
        
    End Sub

    Protected Sub btnBackReferer_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        Response.Redirect(HttpRefer)
    End Sub


    Protected Sub webGridAssignments_UpdateRowBatch(ByVal sender As Object, ByVal e As Infragistics.WebUI.UltraWebGrid.RowEventArgs) Handles webGridAssignments.UpdateRowBatch


        'For Each Band As UltraGridBand In webGridAssignments.Bands
        If e.Row.Band.DataKeyField = "proj_assign_id" Then
            If e.Row.DataChanged = DataChanged.Modified Then
                Dim intEstDuration As Integer
                Dim decBookingAmt As Decimal
                Dim decFullrate As Decimal
                Dim margin As Decimal
                Dim decGMAmt As Decimal
                Dim decGMPercentage As Decimal
                Dim intRetCalcVal As Integer

                Dim pdRate As Decimal = CType(e.Row.Cells.FromKey("per_diem").Value, Decimal)
                Dim payRate As Decimal = e.Row.Cells.FromKey("pay_rate").Value
                Dim billRate As Decimal = e.Row.Cells.FromKey("bill_rate").Value
                Dim payFreq As String = e.Row.Cells.FromKey("pay_desc").Value
                Dim pdFreq As String = e.Row.Cells.FromKey("per_diem_desc").Value
                Dim billFreq As String = e.Row.Cells.FromKey("bill_desc").Value
                Dim dtStartDate As Date = e.Row.Cells.FromKey("start_date").Value
                Dim dtEstEndDate As Date = e.Row.Cells.FromKey("est_end_date").Value
                Dim dtEndDate As Date = e.Row.Cells.FromKey("end_date").Value
                Dim strTypeDesc As String = e.Row.Cells.FromKey("type_desc").Value
                Dim intKey As Integer = e.Row.DataKey

                If payFreq = "None" Or billFreq = "None" Then
                    e.Cancel = True
                    WebDialogErr.Visible = True
                    WebDialogErr.Header.CaptionText = "Rate Frequency Error!"
                    lblWarn.Text = "Neither the billing frequency nor the pay frequency can be equal to 'None' when updating records. Please change the rate frequency."
                    WebDialogErr.WindowState = Infragistics.Web.UI.LayoutControls.DialogWindowState.Normal
                    Exit Sub
                End If

                Dim intPDCalc As Integer = FrequencyCalculations.AIMSCalculations.PerDiemHourlyConversion(pdFreq, pdRate)
                Dim intPayCalc As Integer = FrequencyCalculations.AIMSCalculations.PayRateHourlyConversion(payFreq, payRate)
                Dim intBillCalc As Integer = FrequencyCalculations.AIMSCalculations.BillRateHourlyConversion(billFreq, billRate)

                margin = ((intBillCalc - intPayCalc) - intPDCalc)
                decFullrate = FrequencyCalculations.AIMSCalculations.getFullyLoadedRate(strTypeDesc, intPayCalc)
                If Not (dtEndDate = Nothing) Then
                    If Not (dtEndDate <= dtStartDate) Then
                        intEstDuration = FrequencyCalculations.AIMSCalculations.getEstDurationHrs(dtStartDate, dtEndDate)
                    Else
                        e.Cancel = True
                        WebDialogErr.Visible = True
                        WebDialogErr.Header.CaptionText = "Date Range Error!"
                        lblWarn.Text = "The end date cannot be less than or equal to the start date. If this record was created in error, delete the record first, then recreate it. Otherwise, re-enter a valid end date."
                        WebDialogErr.WindowState = Infragistics.Web.UI.LayoutControls.DialogWindowState.Normal
                        Exit Sub
                    End If

                Else
                    If Not (dtEstEndDate <= dtStartDate) Then
                        intEstDuration = FrequencyCalculations.AIMSCalculations.getEstDurationHrs(dtStartDate, dtEstEndDate)
                    Else
                        e.Cancel = True
                        WebDialogErr.Visible = True
                        WebDialogErr.Header.CaptionText = "Date Range Error!"
                        lblWarn.Text = "The etimated end date cannot be less than or equal to the start date. If this record was created in error, delete the record first, then recreate it. Otherwise, re-enter a valid estimated end date."
                        WebDialogErr.WindowState = Infragistics.Web.UI.LayoutControls.DialogWindowState.Normal
                        Exit Sub
                    End If

                End If

                decBookingAmt = (intBillCalc * intEstDuration)
                decGMAmt = (intBillCalc - decFullrate) - intPDCalc
                decGMPercentage = ((decGMAmt * intEstDuration) / decBookingAmt)

                Dim cellPDMargin As UltraGridCell = e.Row.Cells.FromKey("margin")
                Dim cellBookingAmt As UltraGridCell = e.Row.Cells.FromKey("bookingAmt")
                Dim cellGMAmt As UltraGridCell = e.Row.Cells.FromKey("grossMarginAmt")
                Dim cellGMPercent As UltraGridCell = e.Row.Cells.FromKey("grossMarginPercent")
                Try
                    intRetCalcVal = updateCalcs(intKey, intPDCalc, intPayCalc, intBillCalc)
                    If intRetCalcVal <> 1 Then
                        Exit Sub
                    End If
                Catch ex As Exception

                End Try
                cellPDMargin.Value = margin
                cellBookingAmt.Value = decBookingAmt
                cellGMAmt.Value = decGMAmt
                cellGMPercent.Value = decGMPercentage
            End If
        ElseIf e.Row.Band.DataKeyField = "proj_assign_mkt_id" Then
            If e.Row.DataChanged = DataChanged.Modified Then
                Dim dtProjMktStart As Date
                Dim dtProjMktEnd As Date
                If Not (e.Row.Cells.FromKey("proj_mkt_start_date") Is Nothing) Then
                    dtProjMktStart = e.Row.Cells.FromKey("proj_mkt_start_date").Value
                End If
                If Not (e.Row.Cells.FromKey("proj_mkt_end_date") Is Nothing) Then
                    dtProjMktEnd = e.Row.Cells.FromKey("proj_mkt_end_date").Value
                End If

                Select Case dtProjMktEnd
                    Case Nothing
                        ' Update the record.
                    Case Else
                        If dtProjMktEnd < dtProjMktStart Then
                            e.Cancel = True
                            WebDialogErr.Visible = True
                            WebDialogErr.Header.CaptionText = "Date Range Error!"
                            lblWarn.Text = "The market end date cannot be less than market start date. If this record was created in error, delete the record first, then recreate it. Otherwise, re-enter a valid end date."
                            WebDialogErr.WindowState = Infragistics.Web.UI.LayoutControls.DialogWindowState.Normal
                            Exit Sub
                        End If
                End Select
            End If
        End If
        
    End Sub

    Protected Sub btnConsultSearch_Click(ByVal sender As Object, ByVal e As System.EventArgs)

    End Sub

    'Protected Sub ImageButton1_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles ImageButton1.Click
    '    webGridDocEx.Format = Infragistics.Documents.Report.FileFormat.PDF
    '    webGridDocEx.DownloadName = "report.pdf"
    '    webGridDocEx.TargetPaperOrientation = Infragistics.Documents.Report.PageOrientation.Landscape

    '    webGridDocEx.Export(webGridAssignments)
    'End Sub
    'Public Function GetSelectedColumns() As String()
    '    Dim List As New List(Of String)
    '    For Each colNode As Node In webTreeGridCols.Nodes
    '        If colNode.Checked = True Then
    '            List.Add(colNode.Text)
    '        End If
    '    Next
    'End Function

    Protected Sub OkBtn_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles OkBtn.Click
        'webGridDocEx.Format = Infragistics.Documents.Report.FileFormat.PDF
        'webGridDocEx.DownloadName = "report.pdf"
        'webGridDocEx.TargetPaperOrientation = Infragistics.Documents.Report.PageOrientation.Landscape

        'webGridDocEx.Export(webGridAssignments)
    End Sub

    Protected Sub webGridDocEx_BeginExport(ByVal sender As Object, ByVal e As Infragistics.WebUI.UltraWebGrid.DocumentExport.DocumentExportEventArgs) Handles webGridDocEx.BeginExport
        For Each row As GridViewRow In grdViewCols.Rows()
            Dim cb As HtmlInputCheckBox = CType(row.FindControl("ckItem"), HtmlInputCheckBox)
            Dim strColName As String = CType(row.FindControl("lblKey"), Label).Text
            If Not (cb.Checked) Then
                webGridAssignments.Columns.FromKey(strColName).Hidden = True
            End If
        Next
        Dim sName As String = Request.ServerVariables("SERVER_NAME")
        Dim appName As String = Request.ApplicationPath

        Dim heading As ReportText.IText = e.Section.AddText()
        Dim headingStyle As ReportText.Style = New ReportText.Style(New Infragistics.Documents.Graphics.Font("Tahoma", 16), Infragistics.Documents.Graphics.Brushes.Crimson)
        heading.Margins.Bottom = 15

        Dim caption As ReportText.IText = e.Section.AddText()
        caption.AddContent("Create Date: " & Today().ToShortDateString())

        Dim objImage As Infragistics.Documents.Graphics.Image = New Infragistics.Documents.Graphics.Image("http://" & sName & appName & "/Images/AvionLogo.jpg")

        Dim band As Infragistics.Documents.Report.Band.IBand = e.Section.AddBand()
        band.Borders = New Infragistics.Documents.Report.Borders(Infragistics.Documents.Graphics.Pens.Black, 5)
        band.Margins.Vertical = 5
        band.Paddings.All = 5
        band.Background = New Infragistics.Documents.Report.Background(New Infragistics.Documents.Graphics.Color(240, 240, 220))

        band.Footer.Repeat = True
        band.Footer.Borders = New Infragistics.Documents.Report.Borders(Infragistics.Documents.Graphics.Pens.Black, 5)
        band.Footer.Paddings.All = 5
        band.Footer.Background = New Infragistics.Documents.Report.Background(Infragistics.Documents.Graphics.Brushes.LightSeaGreen)

        band.Footer.Repeat = True
        band.Footer.Borders = New Infragistics.Documents.Report.Borders(Infragistics.Documents.Graphics.Pens.Black, 5)
        band.Footer.Paddings.All = 5
        band.Footer.Background = New Infragistics.Documents.Report.Background(Infragistics.Documents.Graphics.Brushes.LightSeaGreen)



        Dim footerText As Infragistics.Documents.Report.Text.IText = band.Header.AddText()
        footerText.AddPageNumber(PageNumberFormat.SmallRoman)
        footerText.AddContent("Copywrite Avion Systems, Inc. 2006")
        footerText = band.Footer.AddText()

        heading.AddContent(objImage)
        heading.AddContent(Chr(20))
        heading.AddContent(txtRptHeader.Text, headingStyle)

    End Sub


    Protected Sub imgBtnPDF_Click(ByVal sender As Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles imgBtnPDF.Click

    End Sub

    Protected Sub UltraWebToolbar1_ButtonClicked(ByVal sender As Object, ByVal be As Infragistics.WebUI.UltraWebToolbar.ButtonEvent) Handles UltraWebToolbar1.ButtonClicked
        Dim btnUnHide As TBarButton = Me.UltraWebToolbar1.Items.FromKey("1")
        Dim btnHide As TBarButton = Me.UltraWebToolbar1.Items.FromKey("2")
        Dim btnRowFltr As TBarButton = Me.UltraWebToolbar1.Items.FromKey("5")
        Dim btnHdrFltr As TBarButton = Me.UltraWebToolbar1.Items.FromKey("6")
        Dim btnTBarButton As Integer = CType(be.Button.Key, String)

        Select Case btnTBarButton
            Case 0
                'For i As Integer = 0 To webGridAssignments.Columns.Count - 1
                '    If Not (Me.webGridAssignments.Rows.ColumnFilters.GetFilterByColumn(Me.webGridAssignments.Columns(i))) Is Nothing Then
                '        For Each fltrCondition As FilterCondition In Me.webGridAssignments.Rows.ColumnFilters.GetFilterByColumn(Me.webGridAssignments.Columns(i)).FilterConditions.All
                '            Dim fltrOperator As String = fltrCondition.ComparisonOperator.ToString()
                '            Dim fltrCompValue As String = fltrCondition.ComparisonOperator.ToString()
                '            lstFltrOper.Items.Add(fltrOperator)
                '            lstFltrCompVal.Items.Add(fltrCompValue)
                '        Next
                '    End If
                'Next
                For Each row As GridViewRow In grdViewCols.Rows()
                    Dim cb As HtmlInputCheckBox = CType(row.FindControl("ckItem"), HtmlInputCheckBox)
                    Dim strColName As String = CType(row.FindControl("lblKey"), Label).Text
                    If Not (cb.Checked) Then
                        webGridAssignments.Columns.FromKey(strColName).Hidden = True
                    End If
                Next

                'webGridAssignments.DisplayLayout.LoadOnDemand = Infragistics.WebUI.UltraWebGrid.LoadOnDemand.NotSet
                wbExcelExporter.ExcelStartRow = 3
                Dim workbook As Infragistics.Excel.Workbook = New Infragistics.Excel.Workbook()
                wbExcelExporter.Export(webGridAssignments)
            Case 1
                webGridAssignments.Columns(3).Hidden = False
                webGridAssignments.Columns(14).Hidden = False
                webGridAssignments.Columns(18).Hidden = False
                webGridAssignments.Columns(19).Hidden = False
                webGridAssignments.Columns(20).Hidden = False
                webGridAssignments.Columns(22).Hidden = False

                btnUnHide.Visible = False
                btnHide.Visible = True
            Case 2
                webGridAssignments.Columns(3).Hidden = True
                webGridAssignments.Columns(14).Hidden = True
                webGridAssignments.Columns(18).Hidden = True
                webGridAssignments.Columns(19).Hidden = True
                webGridAssignments.Columns(20).Hidden = True
                webGridAssignments.Columns(22).Hidden = True

                btnUnHide.Visible = True
                btnHide.Visible = False
            Case 3

            Case 4
                'Select Case Me.webGridAssignments.DisplayLayout.FilterOptionsDefault.FilterUIType
                'Case FilterUIType.HeaderIcons
                Me.webGridAssignments.Bands(0).ColumnFilters.Clear()

                'Case FilterUIType.FilterRow
                For i As Integer = 0 To webGridAssignments.Columns.Count - 1
                    If Not (Me.webGridAssignments.Rows.ColumnFilters.GetFilterByColumn(Me.webGridAssignments.Columns(i))) Is Nothing Then
                        For Each fltrCondition As FilterCondition In Me.webGridAssignments.Rows.ColumnFilters.GetFilterByColumn(Me.webGridAssignments.Columns(i)).FilterConditions.All
                            fltrCondition.ComparisonOperator = FilterComparisionOperator.All
                        Next
                    End If
                Next
                'End Select
                Me.webGridAssignments.DataBind()
            Case 5
                Me.webGridAssignments.DisplayLayout.FilterOptionsDefault.FilterUIType = FilterUIType.FilterRow
                btnRowFltr.Visible = False
                btnHdrFltr.Visible = True
            Case 6
                Me.webGridAssignments.DisplayLayout.FilterOptionsDefault.FilterUIType = FilterUIType.HeaderIcons
                btnRowFltr.Visible = True
                btnHdrFltr.Visible = False
            Case 7
                webGridDocEx.Format = Infragistics.Documents.Report.FileFormat.PDF
                webGridDocEx.DownloadName = "report.pdf"
                webGridDocEx.TargetPaperOrientation = Infragistics.Documents.Report.PageOrientation.Landscape

                webGridDocEx.Export(webGridAssignments)
        End Select
    End Sub

    Protected Sub wbExcelExporter_BeginExport(ByVal sender As Object, ByVal e As Infragistics.WebUI.UltraWebGrid.ExcelExport.BeginExportEventArgs) Handles wbExcelExporter.BeginExport
        e.CurrentWorksheet.Rows(0).Cells(0).Value = txtRptHeader.Text
        e.CurrentWorksheet.Rows(0).Cells(0).CellFormat.Font.Color = System.Drawing.Color.Crimson
        e.CurrentWorksheet.Rows(0).Cells(0).CellFormat.Font.Height = 400
        webGridAssignments.DisplayLayout.LoadOnDemand = Infragistics.WebUI.UltraWebGrid.LoadOnDemand.NotSet
        Me.webGridAssignments.DataBind()
        webGridAssignments.DisplayLayout.LoadOnDemand = Infragistics.WebUI.UltraWebGrid.LoadOnDemand.Xml
    End Sub

    Protected Sub ddlFilterType_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ddlFilterType.SelectedIndexChanged
        GetAssignments()
    End Sub

    Private Function updateCalcs(ByVal intIdentity As Integer, ByVal pdCalc As Integer, ByVal payCalc As Integer, ByVal billCalc As Integer) As Integer
        Dim Retval As Integer
        Dim DBAccess As New PayrollDBAccess.payrollDataAccess()
        Retval = DBAccess.RunSPReturnInteger("updateCalculations", New SqlParameter("@proj_assign_id", intIdentity), New SqlParameter("@per_diem_calc", pdCalc), New SqlParameter("@pay_calc", payCalc), New SqlParameter("@bill_calc", billCalc))
        Return Retval
    End Function

    Protected Sub webImgOK_Click(ByVal sender As Object, ByVal e As Infragistics.WebUI.WebDataInput.ButtonEventArgs) Handles webImgOK.Click
        WebDialogErr.WindowState = Infragistics.Web.UI.LayoutControls.DialogWindowState.Hidden
        WebDialogErr.Visible = False
    End Sub

    Protected Sub WebHierarchDSAssignments_Init(ByVal sender As Object, ByVal e As System.EventArgs) Handles WebHierarchDSAssignments.Init

    End Sub
End Class
